<div class="header">
  <span>Calculators</span>
  <span>
    <mat-icon inline>
      keyboard_arrow_right
    </mat-icon>
  </span>
  <span>Overburden Calculator</span>
</div>
<div class="panel-wrapper">
  <div class="panel" perfectScrollbar>
    <div class="title">
      <h1>
        <button (click)="detailView = false" *ngIf="detailView" mat-icon-button color="primary">
          <mat-icon>keyboard_backspace</mat-icon>
        </button>
        Overburden Calculator
      </h1>

      <button
        *ngIf="!detailView"
        [disabled]="dataSource.length === 0 && dataNoSource.length === 0"
        mat-button
        class="btn-calculator calc"
        (click)="calculate()"
      >
        Calculate
      </button>
    </div>
    <div class="content">
      <ng-container *ngIf="detailView">
        <div class="d-flex">
          <div class="chart">
            <div class="sub-title">
              <h2>OB Gradient</h2>
            </div>
            <overburden-app-line-chart [data]="c1"></overburden-app-line-chart>
          </div>
          <div class="chart">
            <div class="sub-title">
              <h2>OB Pressure</h2>
            </div>
            <overburden-app-line-chart
              [data]="c2"
              [yAxisMax]="1500"
              xAxisLabel="Pressure (psi)"
            ></overburden-app-line-chart>
          </div>
          <div class="chart">
            <overburden-density-chart
              *ngIf="detailView"
              [data]="dataSource"
              [noData]="dataNoSource"
            ></overburden-density-chart>
          </div>
        </div>
      </ng-container>
      <ng-container *ngIf="!detailView">
        <div class="row">
          <aside>
            <div class="sub-title">
              <h2>Input parameters</h2>
            </div>
            <div class="filter">
              <div class="text-box">
                <span class="title-box">Name</span>
                <div class="input-here">
                  <input type="text" placeholder="Name" [(ngModel)]="dataInputs.name" xrdOnlyNumber />
                </div>
              </div>
              <div class="text-box">
                <span class="title-box">Description</span>
                <div class="input-here">
                  <input type="text" placeholder="Description" [(ngModel)]="dataInputs.description" xrdOnlyNumber />
                </div>
              </div>
              <div class="text-box">
                <span class="title-box">Units</span>
                <div class="input-here no-margin">
                  <mat-form-field>
                    <mat-select placeholder="-- Select Unit --" [(value)]="dataInputs.units" disableRipple>
                      <mat-option *ngFor="let option of optionsUnits" [value]="option.id">
                        {{ option.label }}
                      </mat-option>
                    </mat-select>
                  </mat-form-field>
                </div>
              </div>
              <div class="text-box">
                <span class="title-box">Air Gap</span>
                <div
                  class="input-here"
                  [ngClass]="{ 'show-unit': dataInputs.airGap === '', 'is-invalid': showError && !dataInputs.airGap }"
                >
                  <input
                    type="text"
                    placeholder="Air Gap"
                    [(ngModel)]="dataInputs.airGap"
                    (ngModelChange)="checkTotalVerticalDept()"
                    xrdOnlyNumber
                  />
                  <span class="txt-unit">{{ dataInputs.units }}</span>
                </div>
              </div>
              <div class="text-box">
                <span class="title-box">Avg. Water Density </span>
                <div
                  class="input-here"
                  [ngClass]="{
                    'show-unit': dataInputs.avgWaterDensity === '',
                    'is-invalid': showError && !dataInputs.avgWaterDensity
                  }"
                >
                  <input
                    type="text"
                    placeholder="Avg. Water Density "
                    [(ngModel)]="dataInputs.avgWaterDensity"
                    xrdOnlyNumber
                  />
                  <span class="txt-unit">lbs/gal</span>
                </div>
              </div>
              <div class="text-box">
                <span class="title-box">Water Depth</span>
                <div
                  class="input-here"
                  [ngClass]="{
                    'show-unit': dataInputs.waterDepth === '',
                    'is-invalid': showError && !dataInputs.waterDepth
                  }"
                >
                  <input
                    type="text"
                    placeholder="Water Depth"
                    [(ngModel)]="dataInputs.waterDepth"
                    (ngModelChange)="checkTotalVerticalDept()"
                    xrdOnlyNumber
                  />
                  <span class="txt-unit">{{ dataInputs.units }}</span>
                </div>
              </div>
              <div class="text-box">
                <span class="title-box">Total Vertical Depth</span>
                <div
                  class="input-here"
                  [ngClass]="{
                    'show-unit': dataInputs.totalVerticalDepth === '',
                    'is-invalid': (showError && !dataInputs.totalVerticalDepth) || totalDepthError
                  }"
                >
                  <input
                    type="text"
                    placeholder="Total Vertical Depth"
                    [(ngModel)]="dataInputs.totalVerticalDepth"
                    (ngModelChange)="checkTotalVerticalDept()"
                    xrdOnlyNumber
                  />
                  <span class="txt-unit">{{ dataInputs.units }}</span>
                </div>
              </div>
            </div>
          </aside>
          <div class="display-area" *ngIf="selectedData === false">
            <div class="sub-title">
              <h2>Import from file with No Data Zone and/or Data Zone</h2>
            </div>
            <div class="file-dropzone">
              <file-drop
                class="file-drop"
                accept=".csv"
                [showBrowseBtn]="true"
                browseBtnLabel="Select file"
                dropZoneClassName="drag-and-drop"
                contentClassName="drag-and-drop__content"
                browseBtnClassName="drag-and-drop__button"
                (onFileDrop)="dropped($event)"
              >
                <div class="drag-and-drop__text">
                  <img src="/assets/images/icon-view-list.svg" alt="Drag & Drop CSV file here" />
                  <span>Drag & Drop CSV file here</span>
                </div>
              </file-drop>
            </div>
            <div class="form-row">
              <label>Import from the previous run</label>
              <mat-form-field>
                <mat-select
                  placeholder="Select file to import..."
                  [(value)]="dataInputs.units"
                  (selectionChange)="openSelectedFile($event)"
                  disableRipple
                >
                  <mat-option *ngFor="let option of optionsRecentlyOpen" [value]="option.id">
                    {{ option.label }}
                  </mat-option>
                </mat-select>
              </mat-form-field>
            </div>
            <div class="form-row">
              <label>Or you can add data manually</label>
              <button mat-button class="btn-calculator export" (click)="addManually()">Add Manually</button>
            </div>
          </div>

          <!-- exported data -->
          <div class="display-area" *ngIf="selectedData">
            <div class="sub-title">
              <h2>{{ manual ? 'Manual input' : 'File ' + fileName }}</h2>
              <a (click)="backToImport()" href="javascript:;">Back to Import</a>
            </div>
            <div class="table-header">
              <h3>No Data Zone</h3>
              <span>Depth = (Total Vertical Depth - Water Depth - Air Gap)</span>
            </div>

            <div class="table-header">
              <h3>Data Zone</h3>
              <span>{{ dataSource.length }} records (0 ft — 5000 ft) </span>
            </div>
            <div class="table-container">
              <table mat-table [dataSource]="dataSource">
                <!-- Position Column -->
                <ng-container matColumnDef="from">
                  <th mat-header-cell *matHeaderCellDef>Depth Range From (ft)</th>
                  <td mat-cell *matCellDef="let element">
                    <div class="text-box" *ngIf="element.edit">
                      <div class="input-here">
                        <input type="text" [(ngModel)]="element.from" xrdOnlyNumber />
                      </div>
                    </div>

                    <span *ngIf="!element.edit">
                      {{ element.from }}
                    </span>
                  </td>

                  <td mat-footer-cell *matFooterCellDef>
                    <div class="text-box">
                      <div class="input-here">
                        <input type="text" [(ngModel)]="dataInput.from" xrdOnlyNumber />
                      </div>
                    </div>
                  </td>
                </ng-container>

                <!-- Name Column -->
                <ng-container matColumnDef="to">
                  <th mat-header-cell *matHeaderCellDef>Depth Range To (ft)</th>
                  <td mat-cell *matCellDef="let element">
                    <div class="text-box" *ngIf="element.edit">
                      <div class="input-here">
                        <input type="text" [(ngModel)]="element.to" xrdOnlyNumber />
                      </div>
                    </div>

                    <span *ngIf="!element.edit">
                      {{ element.to }}
                    </span>
                  </td>

                  <td mat-footer-cell *matFooterCellDef>
                    <div class="text-box">
                      <div class="input-here">
                        <input type="text" [(ngModel)]="dataInput.to" xrdOnlyNumber />
                      </div>
                    </div>
                  </td>
                </ng-container>

                <!-- Weight Column -->
                <ng-container matColumnDef="density">
                  <th mat-header-cell *matHeaderCellDef>Avg. Density</th>
                  <td mat-cell *matCellDef="let element">
                    <div class="text-box" *ngIf="element.edit">
                      <div class="input-here">
                        <input type="text" [(ngModel)]="element.density" xrdOnlyNumber />
                      </div>
                    </div>

                    <span *ngIf="!element.edit">
                      {{ element.density }}
                    </span>
                  </td>

                  <td mat-footer-cell *matFooterCellDef>
                    <div class="text-box">
                      <div class="input-here">
                        <input type="text" [(ngModel)]="dataInput.density" xrdOnlyNumber />
                      </div>
                    </div>
                  </td>
                </ng-container>

                <!-- Symbol Column -->
                <ng-container matColumnDef="action">
                  <th mat-header-cell *matHeaderCellDef>&nbsp;</th>
                  <td mat-cell *matCellDef="let element">
                    <div *ngIf="element.edit">
                      <button mat-button class="btn-calculator border-only" (click)="saveData(element)">Update</button>
                    </div>
                    <div *ngIf="!element.edit">
                      <a (click)="removeData(element)" href="javascript:;">Remove</a>
                      <a (click)="editData(element)" href="javascript:;">Edit</a>
                    </div>
                  </td>
                  <td mat-footer-cell *matFooterCellDef>
                    <button mat-button class="btn-calculator border-only" (click)="addData()">Add New</button>
                  </td>
                </ng-container>

                <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>
                <tr mat-row *matRowDef="let row; columns: displayedColumns" [class.invalid]="row.invalid"></tr>

                <ng-container *ngIf="manual">
                  <tr mat-footer-row *matFooterRowDef="displayedColumns; sticky: true"></tr>
                </ng-container>
              </table>
            </div>
          </div>
        </div>
      </ng-container>
    </div>
  </div>
</div>
